---
title: Set.prototype.forEach()
slug: Web/JavaScript/Reference/Global_Objects/Set/forEach
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - Reference
  - set
---
<div>{{JSRef}}</div>

<p>The <strong><code>forEach()</code></strong> method executes a provided function once for each value in the <code>Set</code> object, in insertion order.</p>

<div>{{EmbedInteractiveExample("pages/js/set-prototype-foreach.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>mySet</var>.forEach(<var>callback</var>[, <var>thisArg</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>Function to execute for each element, taking three arguments:</dd>
 <dd>
 <dl>
  <dt><code><var>currentValue</var></code>, <code><var>currentKey</var></code></dt>
  <dd>The current element being processed in the <code>Set</code>. As there are no keys in <code>Set</code>, the value is passed for both arguments.</dd>
  <dt><code><var>set</var></code></dt>
  <dd>The <code>Set</code> object which <code>forEach()</code> was called upon.</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code></dt>
 <dd>Value to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>forEach()</code> method executes the provided <code><var>callback</var></code> once for each value which actually exists in the <code>Set</code> object. It is not invoked for values which have been deleted. However, it is executed for values which are present but have the value <code>undefined</code>.</p>

<p><code><var>callback</var></code> is invoked with <strong>three arguments</strong>:</p>

<ul>
 <li>the <strong>element value</strong></li>
 <li>the <strong>element key</strong></li>
 <li>the <strong><code>Set</code> object being traversed</strong></li>
</ul>

<p>There are no keys in <code>Set</code> objects, however, so the first two arguments are both <strong>values</strong> contained in the {{jsxref("Set")}}. This is to make it consistent with other <code>forEach()</code> methods for {{jsxref("Map.foreach", "Map")}} and {{jsxref("Array.forEach","Array")}}.</p>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>forEach()</code>, it will be passed to <code><var>callback</var></code> when invoked, for use as its <code>this</code> value. Otherwise, the value <code>undefined</code> will be passed for use as its <code>this</code> value. The <code>this</code> value ultimately observable by <code><var>callback</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p>Each value is visited once, except in the case when it was deleted and re-added before <code>forEach()</code> has finished. <code><var>callback</var></code> is not invoked for values deleted before being visited. New values added before <code>forEach()</code> has finished will be visited.</p>

<p><code>forEach()</code> executes the <code><var>callback</var></code> function once for each element in the <code>Set</code> object; it does not return a value.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Logging_the_contents_of_a_Set_object">Logging the contents of a Set object</h3>

<p>The following code logs a line for each element in a <code>Set</code> object:</p>

<pre class="brush:js notranslate">function logSetElements(value1, value2, set) {
    console.log('s[' + value1 + '] = ' + value2);
}

new Set(['foo', 'bar', undefined]).forEach(logSetElements);

// logs:
// "s[foo] = foo"
// "s[bar] = bar"
// "s[undefined] = undefined"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-set.prototype.foreach', 'Set.prototype.forEach')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Set.forEach")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.forEach()")}}</li>
 <li>{{jsxref("Map.prototype.forEach()")}}</li>
</ul>
